<?php
/*
	Plugin Name: InPost for WooCommerce
	Plugin URI: https://wordpress.org/plugins/woo-inpost/
	Description: InPost is an international network of fully automated parcel lockers that are accessible 24/7, meaning no more queues or waiting in, enabling customers to collect, send and return parcels.
	Version: 2.0.25
	Author: Inspire Labs
	Author URI: https://inspirelabs.pl/
	Text Domain: woo-inpost
	Domain Path: /lang/
	Tested up to: 5.9.1

	Copyright 2022 Inspire Labs sp. z o.o.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
if (!defined('ABSPATH')) {
    exit;
}

use InspireLabs\WooInpost\admin\EasyPack_Shipment_Manager;
use InspireLabs\WooInpost\EasyPack;
use InspireLabs\WooInpost\EasyPack_AJAX;
use InspireLabs\WooInpost\EasyPack_API;
use InspireLabs\WooInpost\EasyPack_Helper;

define('WOO_INPOST_PLUGIN_FILE', __FILE__);
define('WOO_INPOST_PLUGIN_DIR', __DIR__);

require_once __DIR__ . "/vendor/autoload.php";


function EasyPack_Dispatch_Orders() {
    return InspireLabs\WooInpost\admin\EasyPack_Dispatch_Orders::EasyPack_Dispatch_Orders();
}

EasyPack_Dispatch_Orders();

EasyPack_Shipment_Manager::init();

/**
 * @return EasyPack
 */
function EasyPack()
{
    return EasyPack::Easypack();
}

/**
 * @return EasyPack_API
 */
function EasyPack_API()
{
    return EasyPack_API::EasyPack_API();
}

/**
 * @return EasyPack_Helper
 */
function EasyPack_Helper()
{
    return EasyPack_Helper::EasyPack_Helper();
}

EasyPack_Helper();

EasyPack_AJAX::init();


if (in_array('woocommerce/woocommerce.php',
  apply_filters('active_plugins', get_option('active_plugins')))
) {
    $_GLOBALS['EasyPack'] = EasyPack();

}
